##
##  imagemagick.spec -- OpenPKG RPM Specification
##  Copyright (c) 2000-2003 Cable & Wireless Deutschland GmbH
##  Copyright (c) 2000-2003 The OpenPKG Project <http://www.openpkg.org/>
##  Copyright (c) 2000-2003 Ralf S. Engelschall <rse@engelschall.com>
##
##  Permission to use, copy, modify, and distribute this software for
##  any purpose with or without fee is hereby granted, provided that
##  the above copyright notice and this permission notice appear in all
##  copies.
##
##  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
##  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
##  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
##  IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
##  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
##  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
##  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
##  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
##  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
##  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
##  OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
##  SUCH DAMAGE.
##

#   package version
%define       V_major 5.5.3
%define       V_minor 2
%if "%{V_minor}" == "0"
%define       V_dist  %{V_major}
%else
%define       V_dist  %{V_major}-%{V_minor}
%endif

#   package information
Name:         imagemagick
Summary:      Graphic Image Conversion Tool
URL:          http://www.imagemagick.org/
Vendor:       John Cristy
Packager:     The OpenPKG Project
Distribution: OpenPKG [BASE]
Group:        Graphics
License:      GPL
Version:      %{V_major}.%{V_minor}
Release:      20030103

#   package options
%option       with_perl   %{l_test -p perl}
%option       with_x11    %{l_test -p x11}

#   list of sources
Source0:      ftp://ftp.imagemagick.org/pub/ImageMagick/ImageMagick-%{V_dist}.tar.gz

#   build information
Prefix:       %{l_prefix}
BuildRoot:    %{l_buildroot}
BuildPreReq:  OpenPKG, openpkg >= 20030103, make, gcc, tiff, jpeg, bzip2, zlib, png, freetype
PreReq:       OpenPKG, openpkg >= 20030103
%if "%{with_perl}" == "yes"
BuildPreReq:  perl
PreReq:       perl
%endif
%if "%{with_x11}" == "yes"
BuildPreReq:  X11
PreReq:       X11
%endif
AutoReq:      no
AutoReqProv:  no

%description
    ImageMagick is a robust collection of tools and libraries to read,
    write, and manipulate an image in many image formats (over 68 major
    formats) including popular formats like TIFF, JPEG, PNG, PDF, Photo
    CD, and GIF. With ImageMagick you can create images dynamically,
    making it suitable for Web applications. You can also resize,
    rotate, sharpen, color reduce, or add special effects to an image
    and save your completed work in the same or differing image format.
    Image processing operations are available from the command line, as
    well as through C, C++, and PERL-based programming interfaces.

%prep
    %setup -q -n ImageMagick-%{V_major}
    %{l_shtool} subst \
        -e 's/\([ ]*tagnames=.*echo.*tagnames,[FC][7X][7X].*\)/ if [ ".$tagnames" = . ]; then \1; fi/' \
        -e 's/\/magick -lMagick/\/magick\/.libs -lMagick/' \
        -e 's/^\(MagickLibSubdir="\)[^"]*\("\)/\1imagemagick\2/' \
        configure

%build
    CC="%{l_cc}" \
    CXX="%{l_cxx}" \
    CFLAGS="%{l_cflags -O} %{l_cppflags tiff}" \
    CPPFLAGS="%{l_cppflags tiff}" \
    CXXFLAGS="%{l_cxxflags -O}" \
    LDFLAGS="%{l_ldflags}" \
    ./configure \
        --prefix=%{l_prefix} \
        --without-magick-plus-plus \
        --enable-lzw \
        --with-tiff \
        --with-jpeg \
        --with-png \
        --without-perl \
%if "%{with_x11}" == "yes"
        --with-x \
        --x-includes=`%{l_prefix}/etc/rc --query x11_incdir` \
        --x-libraries=`%{l_prefix}/etc/rc --query x11_libdir` \
%else
        --without-x \
%endif
        --without-threads
    %{l_make} %{l_mflags}

%install
    rm -rf $RPM_BUILD_ROOT

    %{l_make} %{l_mflags} install \
        AM_MAKEFLAGS="DESTDIR=$RPM_BUILD_ROOT"

%if "%{with_perl}" == "yes"
      ( cd PerlMagick
        %{l_shtool} mkdir -f -p -m 755 \
            $RPM_BUILD_ROOT%{l_prefix}/lib/perl
        %{l_shtool} subst \
            -e "s;-L%{l_prefix}/lib;-L$RPM_BUILD_ROOT%{l_prefix}/lib;g" \
            -e "s;-I%{l_prefix}/include;-I$RPM_BUILD_ROOT%{l_prefix}/include;g" \
            Makefile.PL
        %{l_prefix}/bin/perl Makefile.PL \
            PREFIX=$RPM_BUILD_ROOT%{l_prefix} \
            PERL=%{l_prefix}/bin/perl \
            FULLPERL=%{l_prefix}/bin/perl
        %{l_make} %{l_mflags}
        %{l_make} %{l_mflags} install
      )
%endif

    strip $RPM_BUILD_ROOT%{l_prefix}/bin/* 2> /dev/null || true
    ( cd $RPM_BUILD_ROOT%{l_prefix} || exit 1
      rm -f bin/cgimagick
      rm -f bin/iptcutil
      rm -f man/man4/miff.4
      rm -rf share/ImageMagick/www
      rm -f share/ImageMagick/*.txt
      rm -f share/ImageMagick/*.html
      rm -rf share/ImageMagick/images
      rm -f lib/libMagick.la
    )

%if "%{with_perl}" != "yes"
    %{l_rpmtool} files -v -ofiles -r$RPM_BUILD_ROOT %{l_files_std}
%else
    eval `%{l_prefix}/bin/perl -V:installarchlib -V:installprivlib -V:installsitearch -V:installsitelib`
    %{l_rpmtool} files -v -ofiles -r$RPM_BUILD_ROOT \
        %{l_files_std} \
        '%not %dir %{l_prefix}/lib/perl' \
        '%not %dir %{l_prefix}/lib/perl/*' \
        "%not %dir $installarchlib" \
        "%not %dir $installprivlib" \
        "%not %dir $installsitearch" \
        "%not %dir $installsitelib" \
        "%not %dir $installarchlib/auto" \
        "%not %dir $installprivlib/auto" \
        "%not %dir $installsitearch/auto" \
        "%not %dir $installsitelib/auto"
%endif

%files -f files

%clean
    rm -rf $RPM_BUILD_ROOT

